'********** Copyright 2016 Roku Corp.  All Rights Reserved. **********

function makeMetaData()
    'database(DB) file loaction and its name
    ' DBdir = "pkg:/Database/"
    ' DBfile = DBdir + "Database.json"
    'Get artists data structure
    Content = gethome()
    ' print Content
    'Convert to content meta-data node  
    if Content <> ""
        arr = ParseJson(Content)
    else
        arr = {"data":{}}
    end if
    if arr.data = invalid
        arr.data = {}
    end if

    ContentNode = ConvertToContentNode(arr.data)
    'return result by assigning it to top interface
    m.top.content = ContentNode
end function


function ConvertToContentNode(Content as Object) as Object
    ContentNode = createObject("RoSGNode","ContentNode")
    result = advertisement()
    list = ParseJson(result)
    itemContent = ContentNode.createChild("ContentNode")
    itemContent.title = ""
    for each key in list.data
        if key["type"] <> 5 and key["type"] <> 6
            Continue for
        end if
        subItemContent = itemContent.createChild("ContentNode")
        subItemContent.title = ""
        subItemContent.hdposterurl = key.img
        subItemContent.Description = "adv"
        data = CreateObject("roAssociativeArray")
        data["mid"] = key.url.ToInt()
        if key["type"] = 6
            data["box_type"] = 2
        elseif key["type"] = 5
            data["box_type"] = 1
        end if
        subItemContent.addField("data", "assocarray", false)
        subItemContent.data = data
    end for
    for each key in Content
        if key["list"].Count() > 0 and key["type"] <> "cat" and key["type"] <> "playlist" then
            itemContent = ContentNode.createChild("ContentNode")
            itemContent.title = key["name"]
            subItems = key["list"]
            for each subItem in subItems
                subItemContent = itemContent.createChild("ContentNode")
                subItemContent.title = subItem.title
                subItemContent.hdposterurl = subItem.poster
                subItemContent.Description = key.type
                data = CreateObject("roAssociativeArray")
                data["mid"] = subItem.id
                data["box_type"] = subItem.box_type
                data["imdb_rating"] = subItem.imdb_rating
                data["tomato_meter"] = subItem.tomato_meter
                data["tomato_meter_state"] = subItem.tomato_meter_state
                if subItem.box_type = 2
                    data["season_episode"] = subItem.season_episode
                else
                    if subItem.quality_tag_new <> invalid
                        data["quality_tag_new"] = subItem.quality_tag_new
                    end if
                end if
                subItemContent.addField("data", "assocarray", false)
                subItemContent.data = data
            end for
            if key["ismore"] = 1
                subItemContent = itemContent.createChild("ContentNode")
                subItemContent.title = ""
                subItemContent.hdposterurl = "pkg:/images/more_cover.png"
                subItemContent.Description = ""
                data = CreateObject("roAssociativeArray")
                data["mid"] = 0
                data["type"] = key.type
                data["name"] = key.name
                subItemContent.addField("data", "assocarray", false)
                subItemContent.data = data
            end if
        end if
    end for
    return ContentNode
end function


function getDatabase(fileDir as string, fileName as String) as object
    'get data from source
    rawText = ReadAsciiFile(fileName)
    
    'Parse JSON string
    dbJson = parseJSON(rawText)
    'Convert data to AA with artist name as keys name
    db = {}
    for each artist in dbJson.artists
        for each album in artist.albums
            album.artwork = PosterUrlsDynamic()
        end for
        db[artist.name] = artist.albums
		print "db[artist.name] = " + artist.name
    end for
    return db
end function

function PosterUrlsDynamic() as Object
    if m.PosterCounter = invalid then
        itemUri = "http://devtools.web.roku.com/samples/images/Portrait_"
        format = ".jpg"
        m.PosterCounter = 0
        m.PosterUrls = []
        for i = 1 to 12
            m.PosterUrls.Push(itemUri + i.toStr() + format)   
        end for 
    else if m.PosterCounter > 10
        m.PosterCounter = 0
    else     
        m.PosterCounter = m.PosterCounter + 1
    end if
    return m.PosterUrls[m.PosterCounter]
end function

function gethome()
    deviceinfo = CreateObject("roDeviceInfo")
    udid = deviceinfo.GetChannelClientId()
    arr = CreateObject("roAssociativeArray")
    arr["module"] = "Home_list_type_v5"
    user = CreateObject("roRegistrySection", "User")
    uid = user.Read("uid_v2")
    arr["uid"] = uid
    arr["type"] = "all"
    arr["page"] = "1"
    arr["pagelimit"] = "10"
    arr["lang"] = "en"
    arr["open_udid"] = udid

    result = api(arr)
    return result
end function

function advertisement()
    deviceinfo = CreateObject("roDeviceInfo")
    udid = deviceinfo.GetChannelClientId()
    arr = CreateObject("roAssociativeArray")
    arr["module"] = "Advertisement_v3"
    user = CreateObject("roRegistrySection", "User")
    uid = user.Read("uid_v2")
    arr["uid"] = uid
    arr["adv_id"] = "6"
    arr["platform"] = "tvos"
    arr["app_version"] = "6.0"
    arr["appid"] = "web"
    arr["open_udid"] = udid
  
    result = api(arr)
    return result
  end function

function api(arr)
    date = CreateObject("roDateTime")
    arr["expired_date"] = date.AsSeconds() + 3600
    json = FormatJson(arr)
    data2 = CreateObject("roByteArray")
    data2.FromAsciiString(json)
    
    iv = "wEiphTn!"
    appkey = "moviebox"
    cipher = CreateObject("roEVPCipher")
    cipher.Setup(true, "des-cbc", "4a793339686c2134", "7745697068546e21", 1)
    ct = cipher.Process(data2)
    ct = ct.ToBase64String()
    ba = CreateObject("roByteArray")
    ba.FromAsciiString(appkey)
    digest = CreateObject("roEVPDigest")
    digest.Setup("md5")
    ak = digest.Process(ba)
    ba2 = CreateObject("roByteArray")
    ba2.FromAsciiString(ak+"Jy39hl!4"+ct)
    digest2 = CreateObject("roEVPDigest")
    digest2.Setup("md5")
    verify = digest.Process(ba2)
    arr2 = {"app_key":ak,"encrypt_data":ct,"verify":verify}
    json2 = FormatJson(arr2)
    ba3 = CreateObject("roByteArray")
    ba3.FromAsciiString(json2)
    param = ba3.ToBase64String()
    request = CreateObject("roUrlTransfer")
    param = request.Escape(param)
    url = "https://mbpapi.shegu.net/api/api_client/index"
    'request = CreateObject("roUrlTransfer")
    request.SetUrl(url+"?data="+param+"&appid=28")
    request.EnablePeerVerification(false)
    request.EnableHostVerification(false)
    port = CreateObject("roMessagePort")
	  request.SetMessagePort(port)
    If (request.AsyncGetToString())
      msg = Wait(10000, request.GetPort())
      If msg = invalid Then
        ' Timeout
        return ""
      Else If Type( msg ) = "roUrlEvent" Then
        response = msg.GetString()
        result = response.Trim()
        return result
      End If
    End If
    ' response = request.GetToString()
    ' encryptedData2 = response.Trim()
    ' return encryptedData2
end function
