'********** Copyright 2016 Roku Corp.  All Rights Reserved. **********

function makeMetaData()
    'database(DB) file loaction and its name
    ' DBdir = "pkg:/Database/"
    ' DBfile = DBdir + "Database.json"
    'Get artists data structure
    Content = gettvs()
    ' print Content
    'Convert to content meta-data node  
    if Content <> ""
        arr = ParseJson(Content)
    else
        arr = {"data":{}}
    end if
    if arr.data = invalid
        arr.data = {}
    end if
    ContentNode = ConvertToContentNode(arr.data)
    'return result by assigning it to top interface
    m.top.content = ContentNode
end function


function ConvertToContentNode(Content as Object) as Object
    ContentNode = createObject("RoSGNode","ContentNode")
    ' count = 0
    for each key in Content
        ItemContent = ContentNode.createChild("ContentNode")
        ItemContent.title = key.title
        ItemContent.shortdescriptionline1 = key.title
        ItemContent.hdposterurl = key.poster
        data = CreateObject("roAssociativeArray")
        data["mid"] = key.id
        data["box_type"] = key.box_type
        data["imdb_rating"] = key.imdb_rating
        data["tomato_meter"] = key.tomato_meter
        if key.tomato_meter_state <> invalid
            data["tomato_meter_state"] = key.tomato_meter_state
        else
            data["tomato_meter_state"] = ""
        end if
        if key.season_episode <> invalid
            data["season_episode"] = key.season_episode
        end if
        ItemContent.addField("data", "assocarray", false)
        ItemContent.data = data
    end for
    return ContentNode
end function


function gettvs()
    page = m.top.page
    arr = CreateObject("roAssociativeArray")
    arr["module"] = "TV_list_v2"
    user = CreateObject("roRegistrySection", "User")
    uid = user.Read("uid_v2")
    arr["uid"] = uid
    ' arr["uid_token"] = user.Read("uid_token")
    arr["year"] = ""
    arr["rating"] = ""
    arr["quality"] = ""
    arr["cid"] = []
    arr["orderby"] = "add"
    if page <> invalid
        arr["page"] = page
    else
        arr["page"] = "1"
    end if
    arr["pagelimit"] = "24"
    arr["lang"] = "en"
    deviceinfo = CreateObject("roDeviceInfo")
    udid = deviceinfo.GetChannelClientId()
    arr["open_udid"] = udid
    
    result = api(arr)
    return result
end function

function api(arr)
    date = CreateObject("roDateTime")
    arr["expired_date"] = date.AsSeconds() + 3600
    json = FormatJson(arr)
    data2 = CreateObject("roByteArray")
    data2.FromAsciiString(json)
    
    iv = "wEiphTn!"
    appkey = "moviebox"
    cipher = CreateObject("roEVPCipher")
    cipher.Setup(true, "des-cbc", "4a793339686c2134", "7745697068546e21", 1)
    ct = cipher.Process(data2)
    ct = ct.ToBase64String()
    ba = CreateObject("roByteArray")
    ba.FromAsciiString(appkey)
    digest = CreateObject("roEVPDigest")
    digest.Setup("md5")
    ak = digest.Process(ba)
    ba2 = CreateObject("roByteArray")
    ba2.FromAsciiString(ak+"Jy39hl!4"+ct)
    digest2 = CreateObject("roEVPDigest")
    digest2.Setup("md5")
    verify = digest.Process(ba2)
    arr2 = {"app_key":ak,"encrypt_data":ct,"verify":verify}
    json2 = FormatJson(arr2)
    ba3 = CreateObject("roByteArray")
    ba3.FromAsciiString(json2)
    param = ba3.ToBase64String()
    request = CreateObject("roUrlTransfer")
    param = request.Escape(param)
    url = "https://mbpapi.shegu.net/api/api_client/index"
    ' request = CreateObject("roUrlTransfer")
    request.SetUrl(url+"?data="+param+"&appid=28")
    request.EnablePeerVerification(false)
    request.EnableHostVerification(false)
    port = CreateObject("roMessagePort")
	request.SetMessagePort(port)
    If (request.AsyncGetToString())
      msg = Wait(10000, request.GetPort())
      If msg = invalid Then
        ' Timeout
        return ""
      Else If Type( msg ) = "roUrlEvent" Then
        response = msg.GetString()
        result = response.Trim()
        return result
      End If
    End If
    ' response = request.GetToString()
    ' encryptedData2 = response.Trim()
    ' return encryptedData2
end function