'********** Copyright 2016 Roku Corp.  All Rights Reserved. **********

function init()
    m.video = m.top.findNode("my_video")
    m.skiptip = m.top.findNode("skiptip")
    m.skiptip_end = m.top.findNode("skiptip_end")
    m.skip_text = m.top.FindNode("skip_text")
    m.skip_text2 = m.top.FindNode("skip_text2")
    m.subbg = m.top.findNode("subbg")
    m.textshadow = m.top.findNode("textshadow")
    m.subtext = m.top.findNode("subtext")
    m.fontshadow = m.top.FindNode("fontshadow")
    m.subfont = m.top.FindNode("subfont")
end function

sub OnContentChange()
    m.videoinfo = m.top.content
    m.video.content = m.videoinfo.content
    
    m.current_srt = invalid
    m.srtMap = []
    if Type(m.videoinfo.subtitle_list.select) <> "roArray" and m.videoinfo.subtitle_list.select <> invalid
        if m.videoinfo.subtitle_list.select.file_path <> invalid
            m.srt_delay = m.videoinfo.subtitle_list.select.delay
            m.current_srt = m.videoinfo.subtitle_list.select.sid
            getsrtContent(m.videoinfo.subtitle_list.select.file_path)
        end if
    end if

    arr = m.videoinfo.moviedata
  
    arr["fid"] = m.videoinfo.list[0].fid
    m.videoinfo["moviedata"] = arr
    m.videoset = createObject("RoSGNode", "videosetting")
    m.videoset.content = m.videoinfo
    m.videoset.visible = false
    m.typelist = m.videoset.FindNode("Typelist")
    m.vlist = m.videoset.FindNode("vlist")
    m.vlist.ObserveField("itemSelected", "setquality")
    m.subtitles = m.videoset.FindNode("itemsList")
    m.subtitles.ObserveField("itemSelected", "srtselected")
    m.videoset.observeField("srt_con", "srtSet")
    m.settingbg = m.videoset.FindNode("settingbg")
    m.sub_settingbg = m.videoset.FindNode("sub_settingbg")
    m.subtitle_btns = m.videoset.FindNode("subtitle_btns")
    m.subtitle_btns.ObserveField("itemSelected", "close_subtitle")
    m.srt_btn2 = m.videoset.FindNode("btn2")
    m.srt_time = m.videoset.FindNode("srt_time")
    if m.srt_delay <> invalid
        m.srt_time.text = m.srt_delay.ToStr() + " S"
    end if
    if m.current_srt = invalid
        m.srt_btn2.visible = false
    end if
    m.subtitle_delay = m.videoset.FindNode("subtitle_delay")
    m.subtitle_delay.ObserveField("itemSelected", "srt_delay")
    m.top.appendChild(m.videoset)
    user = CreateObject("roRegistrySection", "User")
    if user.Exists("srt_size") = true
        m.srt_size = user.Read("srt_size")
        m.srt_size = m.srt_size.ToInt()
    end if
    if m.srt_size = invalid
        m.srt_size = 28
    end if
    m.srt_sizetxt = m.videoset.FindNode("srt_size")
    if m.srt_size <> 28
        m.srt_sizetxt.text = m.srt_size.ToStr()
        m.fontshadow.size = m.srt_size + 1
        m.subfont.size = m.srt_size
    end if
    m.subtitle_size = m.videoset.FindNode("subtitle_size")
    m.subtitle_size.ObserveField("itemSelected", "srt_size2")
    if user.Exists("srt_position") = true
        m.srt_position = user.Read("srt_position")
        m.srt_position = m.srt_position.ToInt()
        m.subbg.translation = [340,m.srt_position]
    end if
    m.subtitle_move = m.videoset.FindNode("subtitle_move")
    m.subtitle_move.ObserveField("itemSelected", "srt_move")
    m.skip2 = 0
    m.skip_end = 0
    m.close_skiptip = 0
    
    if arr.box_type = 2
        if m.videoinfo.skips.start > 0 and m.videoinfo.skips.start > m.videoinfo.seconds
            m.video.seek = m.videoinfo.skips.start
            m.skip2 = m.videoinfo.skips.start
        else
            m.video.seek = m.videoinfo.seconds
        end if
        if m.videoinfo.skips.end > 0
            m.skip_end = m.videoinfo.skips.end
        end if
    else
        if arr.plan_watched <> invalid and arr.plan_watched = 1
            m.video.seek = 0
        else
            m.video.seek = m.videoinfo.seconds
        end if
    end if
    if m.videoinfo.replay = 1
        if arr.box_type = 2
            if m.videoinfo.skips.start > 0
                m.video.seek = m.videoinfo.skips.start
                m.skip2 = m.videoinfo.skips.start
            else
                m.video.seek = 0
            end if
        else
            m.video.seek = 0
        end if
    end if
    m.video.control = "play"
    m.video.visible = true
    m.video.suppressCaptions = true
    m.video.setFocus(true)
    m.video.ObserveField("position", "onPositionChanged")
    m.video.observeField("state", "controlvideoplay")

    ' print m.video

    if m.skip2 > 0
        m.skip_text.text = "Skipped Opening "+m.skip2.ToStr()+"S,"
        m.skiptip.visible = true
        m.skiptimer = CreateObject("roSGNode", "Timer")
        m.skiptimer.duration = 5
        m.skiptimer.control = "start"
        m.skiptimer.ObserveField("fire","hideskip")
    end if
end sub

function setquality()
    video = m.videoinfo.list[m.vlist.itemSelected]
    for i = 0 to m.vlist.content.getChildCount() - 1
        qu = m.vlist.content.getChild(i)
        if qu.SecondaryTitle = "true"
            qu.update({"SecondaryTitle":"false"}, false)
        end if
    end for
    quality = m.vlist.content.getChild(m.vlist.itemSelected)
    quality.update({"SecondaryTitle":"true"}, false)
    if video.quality <> "org"
        quality2 = video.quality
        user = CreateObject("roRegistrySection", "User")
        user.Write("select_quality", quality2)
    end if
    seconds = m.video.position
    m.video.control = "stop"
    videocontent = createObject("RoSGNode","ContentNode")
    videocontent.setField("title",video.filename)
    videocontent.setField("url",video.path)
    m.video.content = videocontent
    m.video.seek = seconds
    m.video.control = "play"
    m.videoset.visible = false
    m.video.setFocus(true)
  end function

function getsrtContent(url as string)
    m.readContentTask = createObject("RoSGNode","ReadsrtFile")
    m.readContentTask.content = url
    m.readContentTask.observeField("content", "getSrt2")
    m.readContentTask.control = "RUN"
end function

function getSrt2()
    srt = m.readContentTask.content
    getSrt(srt,1)
    m.subbg = m.top.FindNode("subbg")
    m.subtext = m.top.FindNode("subtext")
    m.textshadow = m.top.FindNode("textshadow")
end function

function srtSet()
    srt = m.videoset.srt_con
    getSrt(srt,1)
    m.srt_btn2.visible = true
    m.subbg = m.top.FindNode("subbg")
    m.subtext = m.top.FindNode("subtext")
    m.textshadow = m.top.FindNode("textshadow")
end function

' 获取并处理外挂字幕
function getSrt(srtText as string, index as integer)
    m.srtMap = []
    if srtText <> invalid
        srtItem = createSrtArr(srtText)
        m.srtMap[index] = srtItem
    end if
end function

'将 srt 文本转化为字幕数组
function createSrtArr(srt as string) as Object
    ' arr = srt.Split(chr(10)+chr(10))
    reg = CreateObject("roRegex", "\n\n|\r\r|\r\n\r\n", "")
    arr = reg.Split(srt)
    if arr.Count() < 2
        arr = srt.Split(chr(10)+chr(13)+chr(10))
        if arr.Count() < 2
            arr = {}
        end if
    end if
    result = []
    r = CreateObject("roRegex", "<font[^>]*>", "i")

    for each item in arr
        srtObj = {}
        item = item.Trim()
        containArr = item.Split(chr(10))

        if containArr[1] <> invalid
            containArr[1] = containArr[1].Trim()
            reg = CreateObject("roRegex", "^(\d{1,2}):(\d{2}):(\d{2})[\.,](\d{1,3}) --\> (\d{1,2}):(\d{2}):(\d{2})[\.,](\d{1,3})", "g")
            regResult = reg.Match(containArr[1])
            if regResult.Count() = 0
                regResult = reg.Match(containArr[2])
                containArr.shift()
            end if
            
            if regResult <> invalid and regResult.Count() > 0
                timeSplit = regResult[0].Split(" --> ")
                srtObj.from = GetSeconds(timeSplit[0])
                srtObj.to = GetSeconds(timeSplit[1])
                srtObj.Text = containArr.Slice(2).Join(chr(10))
                srtObj.Text = r.ReplaceAll(srtObj.Text, "")
                srtObj.Text = srtObj.Text.Replace("</font>", "")
                ' print srtObj
                result.Push(srtObj)
            end if
        end if
    end for

    return result
end function

' 将时间转化为秒数
function GetSeconds(val as string) as Float
    reg = CreateObject("roRegex", "\,|\.", "")
    arr = reg.Split(val)
    sec = 0
    a = arr[0].Split(":")
    sec = a[0].ToInt() * 60 * 60 + a[1].ToInt() * 60 + a[2].ToInt() + arr[1].ToFloat() / 1000
    return sec
end function

' 获取当前时间对应的字幕内容
function getSubtitle(currentTime as Float, arr as Object) as string
    if arr.Count() = 0 or arr.Count() = 1
        ' print arr
        htmlText = ""
        return htmlText
    end if
    low = 0
    high = arr.Count()
    mid = 0
    htmlText = ""

    while low <= high
        mid = Int((low + high) / 2)
        if arr[mid] <> invalid
            if arr[mid].from <= currentTime and arr[mid].to >= currentTime
                htmlText = arr[mid].Text
                exit while
            end if
            if arr[mid].from > currentTime
                high = mid - 1
            end if
            if arr[mid].to < currentTime
                low = mid + 1
            end if
        else
            exit while
        end if
    end while

    return htmlText
end function

function onPositionChanged(event as object)
    newPosition = event.getData()
    if m.video.duration > 0 and m.skip_end > 0 and m.close_skiptip = 0 and m.skiptip_end.visible = false
        if m.video.duration - newPosition <= m.skip_end
            m.skip_text2.text = "Skip Ending "+m.skip_end.ToStr()+"S,"
            m.skiptip_end.visible = true
        end if
    end if
    if m.srtMap <> invalid and m.srtMap.Count() > 0
        if m.srt_delay <> invalid and (Type(m.srt_delay) = "roInt" or Type(m.srt_delay) = "roInteger")
            newPosition = newPosition + m.srt_delay
        end if
        text = getSubtitle(newPosition+1,m.srtMap[1])
        ' print text
        text = text.Replace("<i>", "")
        text = text.Replace("</i>", "")
        if text = ""
            m.subbg.visible = false
        else
            m.subbg.visible = true
            m.subtext.text = text
            m.textshadow.text = text
        end if
    end if
end function

sub controlvideoplay()
    ' print m.video.state
    ' if m.video.state = "error"
    '     print "111111111"
    '     m.video.control = "stop"
    ' end if
    if m.video.state = "finished"
        m.skiptip.visible = false
        m.skiptip_end.visible = false
    end if
end sub

sub srtselected()
    for i = 0 to m.subtitles.content.getChildCount() - 1
        tt = m.subtitles.content.getChild(i)
        if tt.SecondaryTitle = "true"
            tt.update({"SecondaryTitle":"false"}, false)
        end if
    end for
    info = m.subtitles.content.getChild(m.subtitles.itemSelected)
    info.update({"SecondaryTitle":"true"}, false)
    sid = info.id
    if m.videoinfo.subtitle_list.select = invalid
      m.videoinfo.subtitle_list["select"] = {"sid":sid.ToInt()}
    else
      m.videoinfo.subtitle_list.select.sid = sid.ToInt()
    end if
    m.videoset.content = m.videoinfo
    m.videoset.visible = false
    m.video.setFocus(true)
    m.srt_delay = info.data["delay"]
    m.current_srt = sid
    getsrtContent(info.Description)
    m.srt_time.text = m.srt_delay.ToStr() + " S"
    m.srt_btn2.visible = true
    subtitle_select(sid)
end sub

sub subtitle_select(sid)
    arr = m.videoinfo.moviedata
    arr["sid"] = sid
    arr["type"] = "sub_select"
    
    m.selectContentTask = createObject("RoSGNode","GetContentReader")
    m.selectContentTask.content = arr
    m.selectContentTask.control = "RUN"
end sub

sub close_subtitle()
    index = m.subtitle_btns.itemSelected
    if index = 3
        if m.subtitles.content <> invalid
            for i = 0 to m.subtitles.content.getChildCount() - 1
                tt = m.subtitles.content.getChild(i)
                if tt.SecondaryTitle = "true"
                    tt.update({"SecondaryTitle":"false"}, false)
                end if
            end for
        end if
        m.current_srt = invalid
        m.srt_btn2.visible = false
        m.subbg.visible = false
        m.srtMap = invalid
        m.sub_settingbg.visible = false
        m.videoset.visible = false
        m.settingbg.visible = true
        if m.videoinfo.subtitle_list.select.sid <> invalid
            m.videoinfo.subtitle_list.select.sid = 0
            m.videoset.content = m.videoinfo
        end if
        m.typelist.SetFocus(true)
    end if
end sub

sub srt_delay()
    index = m.subtitle_delay.itemSelected
    if m.srt_delay = invalid
        m.srt_delay = 0
    end if
    if index = 0
        m.srt_delay = m.srt_delay - 1
    else
        m.srt_delay = m.srt_delay + 1
    end if
    m.srt_time.text = m.srt_delay.ToStr() + " S"

    if m.srttimer <> invalid
        m.srttimer.control = "stop"
    end if
    m.srttimer = CreateObject("roSGNode", "Timer")
    m.srttimer.duration = 2
    m.srttimer.control = "start"
    m.srttimer.ObserveField("fire","subtitle_delay")
end sub

sub subtitle_delay()
    arr = m.videoinfo.moviedata
    arr["sid"] = m.current_srt
    arr["delay"] = m.srt_delay
    arr["type"] = "subtitle_delay"
    
    m.delayContentTask = createObject("RoSGNode","GetContentReader")
    m.delayContentTask.content = arr
    m.delayContentTask.control = "RUN"
end sub

sub srt_size2()
    index = m.subtitle_size.itemSelected
    if m.srt_size = invalid
        m.srt_size = 28
    end if
    if index = 0
        m.srt_size = m.srt_size - 1
    else
        m.srt_size = m.srt_size + 1
    end if
    m.srt_sizetxt.text = m.srt_size.ToStr()
    m.fontshadow.size = m.srt_size + 1
    m.subfont.size = m.srt_size
    user = CreateObject("roRegistrySection", "User")
    user.Write("srt_size", m.srt_size.ToStr())
end sub

sub srt_move()
    index = m.subtitle_move.itemSelected
    if m.srt_position = invalid
        m.srt_position = 570
    end if
    if index = 0
        m.srt_position = m.srt_position - 8
    else
        m.srt_position = m.srt_position + 8
    end if
    if m.srt_position < 690 and m.srt_position >= 0
        m.subbg.translation = [340,m.srt_position]
        user = CreateObject("roRegistrySection", "User")
        user.Write("srt_position", m.srt_position.ToStr())
    else
        if m.srt_position < 0
            m.srt_position = 0
        else
            m.srt_position = 690
        end if
    end if
end sub

sub hideskip()
    m.skiptip.visible = false
end sub

function OnKeyEvent(key as String, press as Boolean) as Boolean
    if key = "left"
        if m.skiptip.visible = true and m.videoset.visible = false
            m.video.control = "stop"
            m.video.seek = 0
            m.video.control = "play"
            m.skiptip.visible = false
            return true
        end if
    end if
    if key = "right"
        if m.skiptip_end.visible = true and m.videoset.visible = false
            m.top.removeChild(m.videoset)
            m.videoset = invalid
            m.skiptip.visible = false
            m.skiptip_end.visible = false
            m.video.control = "stop"
            m.top.next_episode = m.videoinfo.moviedata.episode
            return true
        end if
    end if
    result = false
    if press
        ' handle "left" key press
        if key = "up"
            if m.videoset <> invalid and m.videoset.visible = true and m.settingbg.visible = true
                m.videoset.visible = false
                m.video.setFocus(true)
                return true
            end if
        ' handle "right" key press
        else if key = "down"
            if m.videoset <> invalid and m.videoset.visible = true
                return true
            end if
            if m.videoset <> invalid and m.trailerplay = invalid and m.videoset.visible = false and m.settingbg.visible = true
                m.videoset.visible = true
                m.typelist.setFocus(true)
                return true
            end if
        else if key = "back"
            if m.videoset <> invalid and m.videoset.visible = true
                m.videoset.visible = false
                m.video.setFocus(true)
                return true
            end if
            if m.skiptip_end.visible = true
                m.close_skiptip = 1
                m.skiptip_end.visible = false
                return true
            end if
        end if
    end if
    return result
end function